namespace CS
{
    using System;
    using System.Drawing;
    using System.Collections;
    using System.ComponentModel;
    using System.Windows.Forms;
    using System.Data;
    using recls;

    /// <summary>
    /// Summary description for WinForm.
    /// </summary>
    public class WinForm : System.Windows.Forms.Form
    {
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.TextBox searchRoot;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.TextBox pattern;
        private System.Windows.Forms.Button btnSearch;
        private System.Windows.Forms.ListView listFiles;
        private System.Windows.Forms.ListView listProperties;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.ListBox listDirectoryParts;
        private System.Windows.Forms.CheckBox chkRecursive;
        private System.Windows.Forms.CheckBox chkDirectoryParts;
        private System.Windows.Forms.Label lblDirectoryParts;
        private System.Windows.Forms.ProgressBar progbar;
        private System.Windows.Forms.RadioButton rbtnFiles;
        private System.Windows.Forms.RadioButton rbtnDirectories;
        private System.Windows.Forms.RadioButton rbtnBoth;
        private System.Windows.Forms.Label label3;

        public WinForm()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose (bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.label1 = new System.Windows.Forms.Label();
            this.searchRoot = new System.Windows.Forms.TextBox();
            this.label2 = new System.Windows.Forms.Label();
            this.pattern = new System.Windows.Forms.TextBox();
            this.btnSearch = new System.Windows.Forms.Button();
            this.label3 = new System.Windows.Forms.Label();
            this.listFiles = new System.Windows.Forms.ListView();
            this.listProperties = new System.Windows.Forms.ListView();
            this.label4 = new System.Windows.Forms.Label();
            this.lblDirectoryParts = new System.Windows.Forms.Label();
            this.listDirectoryParts = new System.Windows.Forms.ListBox();
            this.chkRecursive = new System.Windows.Forms.CheckBox();
            this.chkDirectoryParts = new System.Windows.Forms.CheckBox();
            this.progbar = new System.Windows.Forms.ProgressBar();
            this.rbtnFiles = new System.Windows.Forms.RadioButton();
            this.rbtnDirectories = new System.Windows.Forms.RadioButton();
            this.rbtnBoth = new System.Windows.Forms.RadioButton();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(100, 16);
            this.label1.TabIndex = 0;
            this.label1.Text = "Search &root:";
            // 
            // searchRoot
            // 
            this.searchRoot.Location = new System.Drawing.Point(112, 16);
            this.searchRoot.Name = "searchRoot";
            this.searchRoot.Size = new System.Drawing.Size(632, 20);
            this.searchRoot.TabIndex = 1;
            this.searchRoot.Text = "";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 56);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(100, 16);
            this.label2.TabIndex = 2;
            this.label2.Text = "&Pattern:";
            // 
            // pattern
            // 
            this.pattern.Location = new System.Drawing.Point(112, 48);
            this.pattern.Name = "pattern";
            this.pattern.TabIndex = 3;
            this.pattern.Text = "*.*";
            // 
            // btnSearch
            // 
            this.btnSearch.Location = new System.Drawing.Point(664, 48);
            this.btnSearch.Name = "btnSearch";
            this.btnSearch.Size = new System.Drawing.Size(80, 23);
            this.btnSearch.TabIndex = 9;
            this.btnSearch.Text = "&Search";
            this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(8, 88);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(100, 16);
            this.label3.TabIndex = 10;
            this.label3.Text = "F&iles:";
            // 
            // listFiles
            // 
            this.listFiles.Location = new System.Drawing.Point(8, 104);
            this.listFiles.MultiSelect = false;
            this.listFiles.Name = "listFiles";
            this.listFiles.Size = new System.Drawing.Size(384, 368);
            this.listFiles.TabIndex = 11;
            this.listFiles.View = System.Windows.Forms.View.Details;
            this.listFiles.SelectedIndexChanged += new System.EventHandler(this.listFiles_SelectedIndexChanged);
            // 
            // listProperties
            // 
            this.listProperties.Location = new System.Drawing.Point(400, 104);
            this.listProperties.Name = "listProperties";
            this.listProperties.Size = new System.Drawing.Size(344, 224);
            this.listProperties.TabIndex = 13;
            this.listProperties.View = System.Windows.Forms.View.Details;
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(408, 88);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(100, 16);
            this.label4.TabIndex = 12;
            this.label4.Text = "Pr&operties";
            // 
            // lblDirectoryParts
            // 
            this.lblDirectoryParts.Location = new System.Drawing.Point(400, 336);
            this.lblDirectoryParts.Name = "lblDirectoryParts";
            this.lblDirectoryParts.Size = new System.Drawing.Size(120, 16);
            this.lblDirectoryParts.TabIndex = 14;
            this.lblDirectoryParts.Text = "Directory par&ts:";
            // 
            // listDirectoryParts
            // 
            this.listDirectoryParts.Location = new System.Drawing.Point(400, 352);
            this.listDirectoryParts.Name = "listDirectoryParts";
            this.listDirectoryParts.Size = new System.Drawing.Size(344, 121);
            this.listDirectoryParts.TabIndex = 15;
            // 
            // chkRecursive
            // 
            this.chkRecursive.Checked = true;
            this.chkRecursive.CheckState = System.Windows.Forms.CheckState.Checked;
            this.chkRecursive.Location = new System.Drawing.Point(224, 56);
            this.chkRecursive.Name = "chkRecursive";
            this.chkRecursive.Size = new System.Drawing.Size(96, 16);
            this.chkRecursive.TabIndex = 4;
            this.chkRecursive.Text = "Recursi&ve";
            // 
            // chkDirectoryParts
            // 
            this.chkDirectoryParts.Checked = true;
            this.chkDirectoryParts.CheckState = System.Windows.Forms.CheckState.Checked;
            this.chkDirectoryParts.Location = new System.Drawing.Point(328, 56);
            this.chkDirectoryParts.Name = "chkDirectoryParts";
            this.chkDirectoryParts.Size = new System.Drawing.Size(104, 16);
            this.chkDirectoryParts.TabIndex = 5;
            this.chkDirectoryParts.Text = "Directory P&arts";
            // 
            // progbar
            // 
            this.progbar.Location = new System.Drawing.Point(8, 480);
            this.progbar.Name = "progbar";
            this.progbar.Size = new System.Drawing.Size(736, 16);
            this.progbar.TabIndex = 11;
            // 
            // rbtnFiles
            // 
            this.rbtnFiles.Appearance = System.Windows.Forms.Appearance.Button;
            this.rbtnFiles.Checked = true;
            this.rbtnFiles.Location = new System.Drawing.Point(440, 48);
            this.rbtnFiles.Name = "rbtnFiles";
            this.rbtnFiles.Size = new System.Drawing.Size(48, 24);
            this.rbtnFiles.TabIndex = 6;
            this.rbtnFiles.TabStop = true;
            this.rbtnFiles.Text = "&Files";
            // 
            // rbtnDirectories
            // 
            this.rbtnDirectories.Appearance = System.Windows.Forms.Appearance.Button;
            this.rbtnDirectories.Location = new System.Drawing.Point(496, 48);
            this.rbtnDirectories.Name = "rbtnDirectories";
            this.rbtnDirectories.Size = new System.Drawing.Size(72, 24);
            this.rbtnDirectories.TabIndex = 7;
            this.rbtnDirectories.Text = "&Directories";
            // 
            // rbtnBoth
            // 
            this.rbtnBoth.Appearance = System.Windows.Forms.Appearance.Button;
            this.rbtnBoth.Location = new System.Drawing.Point(576, 48);
            this.rbtnBoth.Name = "rbtnBoth";
            this.rbtnBoth.Size = new System.Drawing.Size(48, 24);
            this.rbtnBoth.TabIndex = 8;
            this.rbtnBoth.Text = "&Both";
            // 
            // WinForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(752, 499);
            this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                          this.rbtnFiles,
                                                                          this.progbar,
                                                                          this.chkDirectoryParts,
                                                                          this.chkRecursive,
                                                                          this.listDirectoryParts,
                                                                          this.lblDirectoryParts,
                                                                          this.label4,
                                                                          this.listProperties,
                                                                          this.listFiles,
                                                                          this.label3,
                                                                          this.btnSearch,
                                                                          this.pattern,
                                                                          this.label2,
                                                                          this.searchRoot,
                                                                          this.label1,
                                                                          this.rbtnDirectories,
                                                                          this.rbtnBoth});
            this.Name = "WinForm";
            this.Text = "recls C# mapping test";
            this.Load += new System.EventHandler(this.WinForm_Load);
            this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main() 
        {
            Application.Run(new WinForm());
        }
        
        private void btnSearch_Click(object sender, System.EventArgs e)
        {
            progbar.Maximum = 1000;

            RECLS_FLAG  flags = 0;

            if(rbtnBoth.Checked)
            {
                flags |= RECLS_FLAG.RECLS_F_DIRECTORIES | RECLS_FLAG.RECLS_F_FILES;
            }
            else if(rbtnFiles.Checked)
            {
                flags |= RECLS_FLAG.RECLS_F_FILES;
            }
            else if(rbtnDirectories.Checked)
            {
                flags |= RECLS_FLAG.RECLS_F_DIRECTORIES;
            }

            if(chkRecursive.Checked)
            {
                flags |= RECLS_FLAG.RECLS_F_RECURSIVE;
            }

            if(chkDirectoryParts.Checked)
            {
                flags |= RECLS_FLAG.RECLS_F_DIRECTORY_PARTS;
            }

            listDirectoryParts.Enabled = chkDirectoryParts.Checked;
            lblDirectoryParts.Enabled = chkDirectoryParts.Checked;

            FileSearch  fs = new FileSearch(searchRoot.Text, pattern.Text, flags);

            listFiles.Items.Clear();
            listProperties.Items.Clear();
            listDirectoryParts.Items.Clear();

            foreach(FileEntry fe in fs)
            {
                ListViewItem    lvi = new ListViewItem(fe.Path);

                lvi.Tag = fe;

                listFiles.Items.Add(lvi);

                if(1 + progbar.Value == progbar.Maximum)
                {
                    progbar.Value = 0;
                }
                else
                {
                    progbar.Value = 1 + progbar.Value;
                }
                progbar.Update();

                listFiles.Update();
            }

            progbar.Value = 0;
        }

        private void WinForm_Load(object sender, System.EventArgs e)
        {
            int cx;
            
            cx = listFiles.Width - 4;
            listFiles.Columns.Add("Filename", cx, HorizontalAlignment.Left);

            cx = listProperties.Width - 4;
            listProperties.Columns.Add("Property", cx * 2 / 5, HorizontalAlignment.Left);
            listProperties.Columns.Add("Value", cx * 3 / 5, HorizontalAlignment.Left);
        }

        private void listFiles_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            ListView.SelectedListViewItemCollection items = listFiles.SelectedItems;

            if(items.Count == 1)
            {
                PopulateProperties((FileEntry)items[0].Tag);
            }
        }

        private string TranslateEntryAttributes(FileEntry fe)
        {
            string  s   =   "";

            if(fe.IsDirectory)
            {
                if(s.Length > 0)
                {
                    s += " ";
                }
                s += "[Directory]";
            }

            if(fe.IsLink)
            {
                if(s.Length > 0)
                {
                    s += " ";
                }
                s += "[Link]";
            }

            if(fe.IsReadOnly)
            {
                if(s.Length > 0)
                {
                    s += " ";
                }
                s += "[Read only]";
            }

            return s;
        }

        /// <summary>
        /// Populates the properties list, from the given entry
        /// </summary>
        private void PopulateProperties(FileEntry entry)
        {
            listProperties.Items.Clear();
            listDirectoryParts.Items.Clear();

            listProperties.Items.Add("Path").SubItems.Add(entry.Path);
            listProperties.Items.Add("Drive").SubItems.Add(entry.Drive.ToString());
            listProperties.Items.Add("Directory").SubItems.Add(entry.Directory);
            listProperties.Items.Add("DirectoryPath").SubItems.Add(entry.DirectoryPath);
            listProperties.Items.Add("File").SubItems.Add(entry.File);
            listProperties.Items.Add("ShortFile").SubItems.Add(entry.ShortFile);
            listProperties.Items.Add("FileName").SubItems.Add(entry.FileName);
            listProperties.Items.Add("FileExt").SubItems.Add(entry.FileExt);
            listProperties.Items.Add("CreationTime").SubItems.Add(entry.CreationTime.ToString());
            listProperties.Items.Add("ModificationTime").SubItems.Add(entry.ModificationTime.ToString());
            listProperties.Items.Add("LastAccessTime").SubItems.Add(entry.LastAccessTime.ToString());
            listProperties.Items.Add("LastStatusChangeTime").SubItems.Add(entry.LastStatusChangeTime.ToString());
            listProperties.Items.Add("Attributes").SubItems.Add(TranslateEntryAttributes(entry));

            foreach(string part in entry.DirectoryParts)
            {
                listDirectoryParts.Items.Add(part);
            }
        }
    }
}
